# Enum Class DistanceMetric

java.lang.Object
java.lang.Enum<DistanceMetric>
picard.illumina.DistanceMetric

All Implemented Interfaces:
  `Serializable, Comparable<DistanceMetric>, Constable, org.broadinstitute.barclay.argparser.CommandLineParser.ClpEnum`

public enum DistanceMetric extends Enum<DistanceMetric> implements org.broadinstitute.barclay.argparser.CommandLineParser.ClpEnum

## Nested Class Summary

### Nested classes/interfaces inherited from class Enum

`Enum.EnumDesc<E>`

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`FREE`
`HAMMING`
`LENIENT_HAMMING`

## Method Summary

Modifier and Type
Method
Description
`int`
`distance(BarcodeEditDistanceQuery editDistance)`
`protected abstract int`
`distance0(SingleBarcodeDistanceMetric editDistance)`
`String`
`getHelpDoc()`
`static DistanceMetric`
`valueOf(String name)`
Returns the enum constant of this class with the specified name.
`static DistanceMetric[]`
`values()`
Returns an array containing the constants of this enum class, in the order they are declared.

### Methods inherited from class Enum

`clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### HAMMING

public static final DistanceMetric HAMMING

### LENIENT_HAMMING

public static final DistanceMetric LENIENT_HAMMING

### FREE

public static final DistanceMetric FREE

## Method Details

### values

public static DistanceMetric[] values()
Returns an array containing the constants of this enum class, in the order they are declared.

Returns:
  an array containing the constants of this enum class, in the order they are declared

### valueOf

public static DistanceMetric valueOf(String name)
Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum class has no constant with the specified name
  `NullPointerException` - if the argument is null

### distance0

protected abstract int distance0(SingleBarcodeDistanceMetric editDistance)

### distance

public int distance(BarcodeEditDistanceQuery editDistance)

### getHelpDoc

public String getHelpDoc()

Specified by:
  `getHelpDoc` in interface `org.broadinstitute.barclay.argparser.CommandLineParser.ClpEnum`